local BLRCD=BLRCD
local LGIST = LibStub("LibGroupInSpecT-1.0")
local AceDB = LibStub("AceDB-3.0") -- Makes saving things relaly easy
local CB = LibStub("LibCandyBar-3.0")

local Elv = IsAddOnLoaded("ElvUI")

if(Elv) then
	E, L, V, P, G =  unpack(ElvUI);
end

BLRCD.raid_members = {}
BLRCD.cd_helper = {}
BLRCD.handles = {}
BLRCD.classes = {"DEATHKNIGHT","DRUID","HUNTER","MAGE","MONK","PALADIN","PRIEST","ROGUE","SHAMAN","WARLOCK","WARRIOR"}
BLRCD.frames = {}
BLRCD.categories = {}

function BLRCD:GetPartyType()
    return ((select(2, IsInInstance()) == "pvp" and "battleground") or (select(2, IsInInstance()) == "arena" and "battleground") or (IsInRaid() and "raid") or (GetNumSubgroupMembers() > 0 and "party") or "none")
end

BLRCD.ShowIcon = function(frameIcon)
	frameIcon.text:Show()
	BLRCD:BLHeight(frameIcon,32*BLRCD.profileDB.scale);
	BLRCD:BLHeight(frameIcon:GetParent(),32*BLRCD.profileDB.scale);
end

BLRCD.HideIcon = function(frameIcon)
	frameIcon.text:Hide()
	BLRCD:BLHeight(frameIcon,1*BLRCD.profileDB.scale);
	BLRCD:BLHeight(frameIcon:GetParent(),1*BLRCD.profileDB.scale);
end

function BLRCD:Scale()
	for c,cat in pairs(BLRCD.categories) do
		-- cat[1] = frame
		-- cat[2] = mover
		-- cat[3] = liste index cd
	
		BLRCD:BLSize(cat[1] ,32*BLRCD.profileDB.scale,(32*#(cat[3]))*BLRCD.profileDB.scale)
		BLRCD:BLSize(cat[2] ,32*BLRCD.profileDB.scale,(32*#(cat[3]))*BLRCD.profileDB.scale)
		for _,i in pairs(cat[3]) do
			BLRCD:BLHeight(_G['BLRaidCooldown'..i],32*BLRCD.profileDB.scale);
			BLRCD:BLWidth(_G['BLRaidCooldown'..i],145*BLRCD.profileDB.scale);	
			BLRCD:BLSize(_G['BLRaidCooldownIcon'..i],32*BLRCD.profileDB.scale,32*BLRCD.profileDB.scale);
			BLRCD:BLFontTemplate((_G['BLRaidCooldownIcon'..i]).text, 20*BLRCD.profileDB.scale, 'OUTLINE')
		end
	end
end

function BLRCD:BLHeight(frame, height)
	if (Elv) then
		frame:Height(height)
	else
		frame:SetHeight(height)
	end
end

function BLRCD:BLWidth(frame, width)
	if(Elv) then
		frame:Width(width)
	else
		frame:SetWidth(width)
	end
end

function BLRCD:BLSize(frame, height, width)
	if(Elv) then
		frame:Size(height, width)
	else
		frame:SetSize(height, width)
	end
end

function BLRCD:BLPoint(obj, arg1, arg2, arg3, arg4, arg5)
	if(Elv) then
		obj:Point(arg1, arg2, arg3, arg4, arg5)
	else
		obj:SetPoint(arg1, arg2, arg3, arg4, arg5)
	end
end

function BLRCD:BLTexture()
	if(Elv) then
			return E["media"].normTex
	else
		return "Interface\\AddOns\\MyAddOn\\statusbar"	
	end
end

function BLRCD:BLCreateBG(frame)
	if(Elv) then
		local bg = CreateFrame("Frame");
		bg:SetTemplate("Default")
		bg:SetParent(frame)
		bg:ClearAllPoints()
		bg:Point("TOPLEFT", frame, "TOPLEFT", -2, 2)
		bg:Point("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 2, -2)
		bg:SetFrameStrata("MEDIUM")
		bg:Show()
	end
end

function BLRCD:BLFontTemplate(frame, x, y)
	if(Elv) then
		frame:FontTemplate(nil, x, y)
	else
		frame:SetFont("Fonts\\FRIZQT__.TTF", x, y)
	end
end

function BLRCD:print_r ( t )
    local print_r_cache={}
    local function sub_print_r(t,indent)
        if (print_r_cache[tostring(t)]) then
            print(indent.."*"..tostring(t))
        else
            print_r_cache[tostring(t)]=true
            if (type(t)=="table") then
                for pos,val in pairs(t) do
                    if (type(val)=="table") then
                        print(indent.."["..pos.."] => "..tostring(t).." {")
                        sub_print_r(val,indent..string.rep(" ",string.len(pos)+8))
                        print(indent..string.rep(" ",string.len(pos)+6).."}")
                    else
                        print(indent.."["..pos.."] => "..tostring(val))
                    end
                end
            else
                print(indent..tostring(t))
            end
        end
    end
    sub_print_r(t," ")
end

local function barSorter(a, b)
	return a.remaining < b.remaining and true or false
end

-- TODO
BLRCD.tmp={}
function BLRCD:RearrangeBars(anchor)
	if not anchor then return end
    if not next(anchor.bars) then return end
    local frame = anchor:GetParent()
    wipe(BLRCD.tmp)
	
    for bar in pairs(anchor.bars) do
		BLRCD.tmp[#BLRCD.tmp + 1] = bar
	end
	
	if(#BLRCD.tmp>2)then
		frame:SetHeight((16*#BLRCD.tmp)*BLRCD.profileDB.scale);
	else
		frame:SetHeight(32*BLRCD.profileDB.scale);
	end

	table.sort(BLRCD.tmp, barSorter)
	local lastDownBar, lastUpBar = nil, nil
	
	for i, bar in next, BLRCD.tmp do
		local spacing = -6
		bar:ClearAllPoints()
		if not (lastDownBar) then
	      if(BLRCD.profileDB.growth  == "right") then
	    	   bar:SetPoint("TOPLEFT",anchor,"TOPRIGHT", 5, -2)
			elseif(BLRCD.profileDB.growth  == "left") then
	    	   bar:SetPoint("TOPRIGHT",anchor,"TOPLEFT", -5, -2)
		   end	    
		else    
    		bar:SetPoint("TOPLEFT", lastDownBar, "BOTTOMLEFT", 0, -6)
		end
		lastDownBar = bar
	end
end

function BLRCD:CreateBar(frame,cooldown,caster,frameicon,guid)
	local bar = CB:New(BLRCD:BLTexture(), 100, 9)
	frameicon.bars[bar] = true
	bar:Set("raidcooldowns:module", "raidcooldowns")
	bar:Set("raidcooldowns:anchor", frameicon)
	bar:Set("raidcooldowns:key", guid)
	bar:SetParent(frameicon)
	bar:SetFrameStrata("MEDIUM")
	bar:SetColor(.5,.5,.5,1);	
	bar:SetDuration(cooldown['CD'])
	bar:SetClampedToScreen(true)
	local caster = strsplit("-",caster)
	bar:SetLabel(caster)
	
	bar.candyBarLabel:SetJustifyH("LEFT")

	BLRCD:BLCreateBG(bar)
	
	bar:Start()
	BLRCD:RearrangeBars(bar:Get("raidcooldowns:anchor"))
	
	return bar
end

function BLRCD:CancelBars(frameicon)
    for k in pairs(frameicon.bars) do
        k:Stop()
    end
	 
	 BLRCD:RearrangeBars(frameicon) 
end

function BLRCD:ToggleVisibility()
	if (BLRCD.hidden) then
		for c,cat in pairs(BLRCD.categories) do
			cat[1]:Show()
		end
		BLRCD.hidden=nil
	else
		for c,cat in pairs(BLRCD.categories) do
			cat[1]:Hide()
		end		
		BLRCD.hidden=true
	end
end

function BLRCD:ToggleConfigMode()
	if (BLRCD.config) then
		for spell,value in pairs(BLRCD['handles'][1]) do
			BLRCD:StopCD(value[1])
			value[3]:Stop()
		end
		for i,baseclass in pairs(BLRCD.classes) do
			for j, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
				cd[4][1]=nil
				cd[2]:SetText(BLRCD:GetNumAvail(cd[3]))
				if (BLRCD:GetNumTotal(cd[3])==0) then
					BLRCD.HideIcon(cd[2]:GetParent())
				end
			end
		end
		BLRCD['raid_members'][1]=nil
		
		BLRCD.config=nil
	else
		BLRCD['raid_members'][1] = BLRCD['raid_members'][1] or {}			
		BLRCD['raid_members'][1].name="configGuy"

		for i,baseclass in pairs(BLRCD.classes) do
			for j, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
				cd[4][1]=1
				cd[2]:SetText(BLRCD:GetNumAvail(cd[3]))
				if (BLRCD:GetNumTotal(cd[3])>0) then
					BLRCD.ShowIcon(cd[2]:GetParent())
				end
				BLRCD:StartCD(self,cd[3],cd[2],1,"configGuy",cd[2]:GetParent(), cd[3].spellID, nil)
			end
		end
		
		BLRCD.config=true
	end
end

function BLRCD:ToggleMoversLock()
	if (BLRCD.locked) then
		for c,cat in pairs(BLRCD.categories) do
			cat[2]:EnableMouse(false)
			cat[2]:RegisterForDrag(nil)
			cat[2]:Hide()
		end
		print("|cffc41f3bBLT Raid Cooldowns|r: locked")
		BLRCD.locked = nil
	else
		for c,cat in pairs(BLRCD.categories) do
			cat[2]:EnableMouse(true)
			cat[2]:RegisterForDrag("LeftButton")
			cat[2]:Show()
		end
		print("|cffc41f3bBLT Raid Cooldowns|r: unlocked")
		BLRCD.locked = true			
	end
end

BLRCD.OnUpdate = function (frame, event, guid, unit, info)   
    local baseclass = info.class
    local name = info.name
    local global_spec_id = info.global_spec_id
    local talents = info.talents
	if not name or not baseclass or not guid or not global_spec_id or not talents then return end

	if (debug) then print("onUpdate event : guid->", guid, " name->", name) end

	BLRCD['raid_members'][guid] = BLRCD['raid_members'][guid] or {}
	if not BLRCD['raid_members'][guid]['name'] then
		BLRCD['raid_members'][guid]['name'] = name
		BLRCD['raid_members'][guid]['class'] = baseclass
		BLRCD['raid_members'][guid]['talents'] = talents
	end
	
	local oldvalue=1
	for i, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
		oldvalue=cd[4][guid] or oldvalue
		
		if(cd[3].spec or cd[3].talent) then
			if ((cd[3].spec and global_spec_id == cd[3].spec) or (cd[3].talent and (next(talents) and talents[cd[3].spellID]))) then
				cd[4][guid]=oldvalue
			end
		else
			cd[4][guid]=oldvalue
		end
		cd[2]:SetText(BLRCD:GetNumAvail(cd[3]))
		if (BLRCD:GetNumTotal(cd[3])>0) then
			BLRCD.ShowIcon(cd[2]:GetParent())
		end
	end
end

BLRCD.UpdateIcon = function ()
    for i,baseclass in ipairs(BLRCD.classes) do
		for i, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
			if (BLRCD:GetNumTotal(cd[3])>0) then
				BLRCD.ShowIcon(cd[2]:GetParent())
			end
		end
    end
end   


BLRCD.OnRemove = function (frame, event, guid)
	if(BLRCD['handles'][guid]) then
		for spell,value in pairs(BLRCD['handles'][guid]) do
			BLRCD:StopCD(value[1])
			value[3]:Stop()
		end
	end
	for i, cd in ipairs(BLRCD['cd_helper'][BLRCD['raid_members'][guid]['class']]) do
		cd[4][guid]=nil
		if (BLRCD:GetNumTotal(cd[3])==0) then
			BLRCD.HideIcon(cd[2]:GetParent())
		end
	end
	BLRCD['handles'][guid]=nil
	BLRCD['raid_members'][guid]=nil
end

local bossfight=false
local pullTime=0
local lastFight={}

BLRCD.ReinitCDUsage = function ()
	for i,baseclass in pairs(BLRCD.classes) do
		for j, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
			for guid, value in pairs(cd[4]) do
				if (value>0) then
					cd[4][guid]=1
				elseif (value<0) then
					cd[4][guid]=-1
				else
					if (debug) then print("wtf ReinitCDUsage") end
				end
			end
		end
	end
end

BLRCD.snapshotCDusage = function()
	if (debug) then print("snapshot cd usage") end
	
	if (lastFight and lastFight[1]) then
		lastFight[2]={}
		for i,baseclass in pairs(BLRCD.classes) do
			lastFight[2][baseclass] = {}
			for j, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
				lastFight[2][baseclass][cd[3].name] = {}
				for guid, value in pairs(cd[4]) do
					lastFight[2][baseclass][cd[3].name][guid] = (math.abs(value)-1).."/"..((math.floor(lastFight[1] / cd[3].CD)) + 1)
				end
			end
		end
	end
end

BLRCD.ReportUsageCD = function (cooldown)
	if (lastFight and lastFight[1]) then
		SendChatMessage("Fight duration : "..lastFight[1].."s",'RAID')
		SendChatMessage("=== "..cooldown.class.." === "..cooldown.name,'RAID')
		for guid, value in pairs(lastFight[2][cooldown.class][cooldown.name]) do
			SendChatMessage("   "..BLRCD['raid_members'][guid]['name'].." "..value,'RAID')
		end
	end
end

BLRCD.ReportUsage = function (class)
	if (BLRCD['cd_helper'][class]) then
		for j, cd in ipairs(BLRCD['cd_helper'][class]) do
			print("=== ", class, " === ", cd[3].name)
			for guid, value in pairs(cd[4]) do
				print("   "..BLRCD['raid_members'][guid]['name'].." ", math.abs(value)-1, "/", (math.floor(lastFight[1] / cd[3].CD)) + 1)
			end
		end	
	else
		for i,baseclass in pairs(BLRCD.classes) do
			for j, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
				print("=== ", baseclass, " === ", cd[3].name)
				for guid, value in pairs(cd[4]) do
					print("   "..BLRCD['raid_members'][guid]['name'].." ", math.abs(value)-1, "/", (math.floor(lastFight[1] / cd[3].CD)) + 1)
				end
			end
		end
	end
end

local function CombatCheck()
	if (debug) then 
		if (not bossfight) then
			print("CombatCheck - REINIT CD USAGE")
			BLRCD.ReinitCDUsage()
			bossfight=true
			pullTime=GetTime()
		else
			print("CombatCheck - LOL BLIZZ")
		end
	end
end

local function engageCheck()
	if not UnitExists("boss1") then return end
	
	if (not bossfight) then
		if (debug) then print("EngageCheck - REINIT CD USAGE") end
		--if (lastFight and lastFight[1] and (GetTime()-(lastFight[1]+pullTime))>15) then
			BLRCD.ReinitCDUsage()
			bossfight=true
			pullTime=GetTime()
		--else 
		--	if (debug) then print("EngageCheck - LOL BLIZZ²") end
		--end
	else
		if (debug) then print("EngageCheck - LOL BLIZZ") end
	end
end

local function checkForWipe()
	local w = true
	local num = GetNumGroupMembers()
	for i = 1, num do
		local name = GetRaidRosterInfo(i)
		if name then
			if UnitAffectingCombat(name) then
				w = false
			end
		end
	end
	if (w and bossfight) then
		-- end fight boss
		bossfight=false

		-- snapshot CD usage
		lastFight={}
		lastFight[1]=GetTime()-pullTime
		BLRCD.snapshotCDusage()
		
		-- reset all CD > 5min
		for guid, tab_cd in pairs(BLRCD['handles']) do
			for spellID, handle in pairs(tab_cd) do
				-- handle[1] = cooldown
				-- handle[2] = handle stop timer
				-- handle[3] = bar
				if (handle[1][1].CD>=300) then
					BLRCD:StopCD(handle[1])
					BLRCD:CancelTimer(handle[2])
					handle[3]:Stop()
				end
				-- TEST AI
				if (handle[1][1].spellID==1459) then
					BLRCD:StopCD(handle[1])
					BLRCD:CancelTimer(handle[2])
					handle[3]:Stop()
				end
			end
		end
	end
	if not w then BLRCD:ScheduleTimer(checkForWipe, 2) end
end

function BLRCD:INSTANCE_ENCOUNTER_ENGAGE_UNIT()
	engageCheck()
end

function BLRCD:PLAYER_REGEN_DISABLED()
	CombatCheck()
end

function BLRCD:PLAYER_REGEN_ENABLED()
	checkForWipe()
end

local count = 0
function BLRCD:OnInitialize()
	if count == 1 then return end
	LGIST.RegisterCallback(BLRCD, "GroupInSpecT_Update", "OnUpdate")
	LGIST.RegisterCallback(BLRCD, "GroupInSpecT_Remove", "OnRemove")

	BLRCD:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
	BLRCD:RegisterEvent("PLAYER_REGEN_ENABLED")
	BLRCD:RegisterEvent("PLAYER_REGEN_DISABLED") -- A MODIF AVT RELEASE
	BLRCD:RegisterChatCommand("BLTRCD", "SlashProcessor_BLRCD")
	
	BLRCD.db = AceDB:New("BLRCDDB", BLRCD.defaults, true)
	BLRCD.profileDB = BLRCD.db.profile
	BLRCD.profileDB.category = {}

	BLRCD:SetupOptions()
	
    for i,class in ipairs(BLRCD.classes) do
        BLRCD['cd_helper'][class] = {}
    end

	for i, cooldown in pairs(BLRCD.cooldowns) do
		if (BLRCD.db.profile.cooldown[cooldown['name']]) then
			if (not BLRCD.categories[cooldown.category]) then
				BLRCD.categories[cooldown.category]=BLRCD.CreateCatFrame(cooldown)
			end
			BLRCD.CreateCooldown(i, cooldown);
		end
	end
	
	count = 1
end

function BLRCD.ToggleDebug()
	if (debug) then
		print("BLRCD debug OFF")
		debug=nil
	else
		print("BLRCD debug ON")
		debug=true
	end
end

function BLRCD.debugclass(class)
	print("=== ", class, " COOLDOWNS ===")
	if (BLRCD['cd_helper'][class]) then
		for i, cdtable in ipairs(BLRCD['cd_helper'][class]) do
			print("Cooldown ", cdtable[3].name, " (id ", cdtable[3].spellID, ")")
			for guid,value in pairs(cdtable[4]) do
				print("-- ", BLRCD['raid_members'][guid]['name'], " (", guid, ") => ", value)
			end
		end
	else
		print("class not found!")
	end
end

function BLRCD.debugraid(n)
	print("=== DEBUG on ", n, " ===")
	for guid, ptable in pairs(BLRCD['raid_members']) do
		if (ptable.name == n) then
			print("Name : ", n)
			print("Class : ", ptable.class)
			print("Talents : ", ptable.talents)
			for id, talent in pairs(ptable.talents) do
				print("-- ", id, " => ", "idx ", talent.idx, "- tier ", talent.tier, "- column ", talent.column, "- spellid ", talent.spell_id, "- name ",talent.name_localized)
			end
		end
	end
end
 
function BLRCD:SlashProcessor_BLRCD(input)
	local v1, v2 = input:match("^(%S*)%s*(.-)$")
	v1 = v1:lower()

	if v1 == "" then
		print("|cffc41f3bBloodlust Raidcooldowns|r: /bltrcd config - Open configuration panel")
		print("|cffc41f3bBloodlust Raidcooldowns|r: /bltrcd show - Show/Hide frames")
		print("|cffc41f3bBloodlust Raidcooldowns|r: /bltrcd sim - Toggle Simulation Mode (frames unlocked)")
	elseif v1 == "lock" then
		BLRCD:ToggleMoversLock()
	elseif v1 == "report" then
		print("=====================================")
		print("Fight duration : ", lastFight[1], "s")
		BLRCD.ReportUsage(v2)
	elseif v1 == "debug" then
		BLRCD.ToggleDebug()
	elseif v1 == "debugicon" then
		BLRCD.UpdateIcon()
	elseif v1 == "debugraid" then
		BLRCD.debugraid(v2)
	elseif v1 == "debugclass" then
		BLRCD.debugclass(v2)
	elseif v1 == "debugbars" then
		for i,x in pairs(BLRCD['handles']) do print(i,x) end
	elseif v1 == "show" then
		BLRCD:ToggleVisibility()	
	elseif v1 == "config" then
		InterfaceOptionsFrame_OpenToCategory(BLRCD.optionsFrames.general)
	elseif v1 == "sim" then
		BLRCD:ToggleConfigMode()	
		BLRCD:ToggleMoversLock()
	end
end

function BLRCD:StartCD(frame,cooldown,text,guid,caster,frameicon, spell, destName)
	for i, cd in ipairs(BLRCD['cd_helper'][cooldown.class]) do
		if (cd[3]==cooldown) then
			if (cd[4][guid]) then
				if (debug) then print("STARTCD ", guid, BLRCD['raid_members'][guid]['name'], cd[3].name, (cd[4][guid])..">"..(-cd[4][guid]-1)) end
				cd[4][guid]=-cd[4][guid]-1
			else 
				if (debug) then print("guid inconnu wtf", guid) end
			end
			cd[2]:SetText(BLRCD:GetNumAvail(cd[3]))
		end
	end

	if(BLRCD.profileDB.castannounce and BLRCD:GetPartyType()=="raid" and guid~=1) then
		local name = select(1, GetSpellInfo(cooldown['spellID']))
		local txt=caster.." casts "..name
		if (destName) then
			txt=txt.." on "..destName
		end
		txt=txt.."  "..cooldown['CD'].."CD"
		if (BLRCD.profileDB.warnannounce and (UnitIsGroupLeader("player") or UnitIsRaidOfficer("player"))) then
			SendChatMessage(txt ,"RAID_WARNING");
		else
			SendChatMessage(txt ,"RAID");	
		end
	end
		
	local bar = BLRCD:CreateBar(frame,cooldown,caster,frameicon,guid)
	
	local args = {cooldown,guid,frame,text,bar,caster,spell}
	local handle = BLRCD:ScheduleTimer("StopCD", cooldown['CD'],args)
	BLRCD['handles'][guid] = BLRCD['handles'][guid] or {}
	BLRCD['handles'][guid][spell] = {args,handle,bar}
end


function BLRCD:StopCD(args)
	local cooldown=args[1]
	local guid=args[2]
	
	if (BLRCD['handles'][guid]) then
		BLRCD['handles'][guid][cooldown.spellID]=nil
	end
	if (not BLRCD['raid_members'][guid]) then return end
	
	for i, cd in ipairs(BLRCD['cd_helper'][cooldown.class]) do
		if (cd[3]==cooldown) then
			if (cd[4][guid]) then
				if (debug) then print("STOPCD ", guid, BLRCD['raid_members'][guid]['name'], cd[3].name, (cd[4][guid])..">"..(-cd[4][guid])) end
				cd[4][guid]=-cd[4][guid]
			else 
				if (debug) then print("guid inconnu wtf", guid) end
			end
		end
	end
	
	local a = args[5]:Get("raidcooldowns:anchor")
	if a and a.bars and a.bars[args[5]] then
		a.bars[args[5]] = nil
		BLRCD:RearrangeBars(a) 
	end
	
	if(BLRCD.profileDB.cdannounce and BLRCD:GetPartyType()=="raid" and guid~=1) then
		local name = select(1, GetSpellInfo(args[1]['spellID']))
		if (BLRCD.profileDB.warnannounce) then
			SendChatMessage(args[6].."'s "..name.." CD UP" ,"RAID_WARNING");
		else
			SendChatMessage(args[6].."'s "..name.." CD UP" ,"RAID");
		end
	end
		
	args[4]:SetText(BLRCD:GetNumAvail(args[1]))
end

function BLRCD:UpdateCooldown(frame,event,unit,cooldown,text,frameicon, ...)
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local timestamp, type,_, sourceGUID, sourceName,_,_, destGUID, destName = select(1, ...)
		if(type == cooldown['succ']) then
			local spellId, spellName, spellSchool = select(12, ...)
			if(spellId == cooldown['spellID']) then
				if (BLRCD['raid_members'][sourceGUID]) then
					if (debug or ((spellId ~= 1459) and (spellId ~= 115610))) then
						BLRCD:StartCD(frame,cooldown,text,sourceGUID,sourceName,frameicon, spellId, destName)
					end
	         	end
			end
		 end
	end	
end

function BLRCD:GetNumTotal(cooldown)
	local cdtotal=0
	local cdtotal2=0
	for i, cd in ipairs(BLRCD['cd_helper'][cooldown.class]) do
		if (cd[3]==cooldown) then
-- TODO : comprendre pkoi #cd[4] ne renvoie pas le nb d'elem
			for guid, value in pairs(cd[4]) do
				cdtotal2=cdtotal2+1
			end
			cdtotal=#(cd[4])
		end
	end
	return cdtotal2
end

function BLRCD:GetNumAvail(cooldown)
	local cdtotal=0
	for i, cd in ipairs(BLRCD['cd_helper'][cooldown.class]) do
		if (cd[3]==cooldown) then
			for guid, value in pairs(cd[4]) do
				if (value>0) then
					cdtotal=cdtotal+1
				end
			end
		end
	end
	return cdtotal
end

BLRCD.CreateCatFrame = function(cooldown)
	local raidcdbase = CreateFrame("Frame", 'BLRaidCooldownBase'..cooldown["category"]..'_Frame', UIParent)
	--TODO : frame trop grande mais bon osef pour l'instant
	BLRCD:BLSize(raidcdbase,32*BLRCD.profileDB.scale,(32*#BLRCD.cooldowns)*BLRCD.profileDB.scale)

	local raidcdbasemover = CreateFrame("Frame", 'BLRaidCooldownBaseMover'..cooldown["category"]..'_Frame', raidcdbase)
	raidcdbasemover:SetClampedToScreen(true)
	BLRCD:BLPoint(raidcdbasemover,'TOPLEFT', UIParent, 'TOPLEFT', 0, 0)
	BLRCD:BLSize(raidcdbasemover,32*BLRCD.profileDB.scale,16*BLRCD.profileDB.scale)
	if(Elv) then
		raidcdbasemover:SetTemplate()
	--		raidcdbase:SetTemplate()
		
	end
	raidcdbasemover:SetMovable(true)
	raidcdbasemover:SetFrameStrata("HIGH")
	raidcdbasemover:SetScript("OnDragStart", function(self) self:StartMoving() end)
	raidcdbasemover:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	raidcdbasemover:Hide()
	
	BLRCD:BLPoint(raidcdbase,'TOPLEFT', raidcdbasemover, 'TOPLEFT', 0, 0)
	raidcdbase:Show()
	
	return {raidcdbase, raidcdbasemover, {}}
end


BLRCD.CreateCooldown = function (index, cooldown, start)
	local frame = CreateFrame("Frame", 'BLRaidCooldown'..index, BLRCD.categories[cooldown.category][1]);
	BLRCD:BLWidth(frame,145*BLRCD.profileDB.scale);	
	frame:SetClampedToScreen(true);
	
	local frameicon = CreateFrame("Button", 'BLRaidCooldownIcon'..index, frame);
	if(ElvUI) then
		frameicon:SetTemplate()
	--		frame:SetTemplate()
	end
		
	local classcolor = RAID_CLASS_COLORS[string.upper(cooldown.class):gsub(" ", "")]
	frameicon:SetBackdropBorderColor(classcolor.r,classcolor.g,classcolor.b)
	
	
	-- TODO : bars serait mieux sur frame et pas frameicon
	frameicon.bars = {}
	BLRCD:BLWidth(frameicon,32*BLRCD.profileDB.scale)
	frameicon:SetClampedToScreen(true)
	
	-- TODO
	local attachpoint
	if (BLRCD.profileDB.growth=='left') then
		attachpoint='RIGHT'
	else	
		attachpoint='LEFT'
	end
	if (#(BLRCD.categories[cooldown.category][3])==0) then -- pas de CD présent pour cette catégorie
		BLRCD:BLPoint(frame,'TOP'..attachpoint, frame:GetParent(), 'TOP'..attachpoint, 0, 0)
	else
		BLRCD:BLPoint(frame,'TOP'..attachpoint, 'BLRaidCooldown'..(BLRCD.categories[cooldown.category][3][#(BLRCD.categories[cooldown.category][3])]), 'BOTTOM'..attachpoint, 0, -1)
	end
	BLRCD:BLPoint(frameicon,'TOP'..attachpoint, frame, 'TOP'..attachpoint)
	table.insert(BLRCD.categories[cooldown.category][3], index)
	
	frameicon.icon = frameicon:CreateTexture(nil, "OVERLAY");
	frameicon.icon:SetTexCoord(unpack(BLRCD.TexCoords));
	frameicon.icon:SetTexture(select(3, GetSpellInfo(cooldown['spellID'])));
	BLRCD:BLPoint(frameicon.icon,'TOPLEFT', 1, -1)
	BLRCD:BLPoint(frameicon.icon,'BOTTOMRIGHT', -1, 1)
	frameicon.text = frameicon:CreateFontString(nil, 'OVERLAY')
	BLRCD:BLFontTemplate(frameicon.text, 20*BLRCD.profileDB.scale, 'OUTLINE')
	BLRCD:BLPoint(frameicon.text, "CENTER",frameicon, "CENTER", 0, 0)

	BLRCD.HideIcon(frameicon)
	table.insert(BLRCD['cd_helper'][cooldown['class']],{index,frameicon.text,cooldown,{}})       
 	
	frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	frameicon:SetScript("OnEnter", function(self,event, ...)
		BLRCD:OnEnter(self,cooldown)
	end);
    frameicon:RegisterForClicks("LeftButtonDown", "RightButtonDown")
	frameicon:SetScript("PostClick", function(self,event, ...)
		BLRCD:PostClick(cooldown, event)
	end);  
    
   frameicon:SetScript("OnLeave", function(self,event, ...)
		BLRCD:OnLeave()
   end);
	
	frame:SetScript("OnEvent", function(self,event, ...)
		BLRCD:UpdateCooldown(self,event,unit,cooldown,frameicon.text,frameicon, ...)
    end);
		
	frame:Show()
end


function BLRCD:OnEnter(self, cooldown)
	GameTooltip:Hide()
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT",3, 14)
	GameTooltip:ClearLines()
	GameTooltip:AddSpellByID(cooldown['spellID'])

	local classcolor = RAID_CLASS_COLORS[string.upper(cooldown.class):gsub(" ", "")]
	for i, cd in ipairs(BLRCD['cd_helper'][cooldown.class]) do
		if (cd[3]==cooldown) then
			if (lastFight and lastFight[1]) then
				GameTooltip:AddDoubleLine("Last Fight Duration",lastFight[1].."s",255,255,255,255,255,255)
			end
			for guid, value in pairs(cd[4]) do
				if (lastFight and lastFight[1]) then
					GameTooltip:AddDoubleLine(BLRCD['raid_members'][guid]['name'],lastFight[2][cooldown.class][cooldown.name][guid],classcolor.r,classcolor.g,classcolor.b,classcolor.r,classcolor.g,classcolor.b)
				else
					GameTooltip:AddLine(BLRCD['raid_members'][guid]['name'],classcolor.r,classcolor.g,classcolor.b)			
				end
			end
		end
	end

	GameTooltip:Show()
end

function BLRCD:PostClick(cooldown, button)
	if (button == "RightButton") then
		BLRCD.ReportUsageCD(cooldown)
	else
		if(BLRCD.profileDB.clickannounce and BLRCD:GetPartyType()=="raid") then
			local name = GetSpellInfo(cooldown['spellID'])
			SendChatMessage('----- '..name..' -----','RAID')
			for i, cd in ipairs(BLRCD['cd_helper'][cooldown.class]) do
				if (cd[3]==cooldown) then
					for guid, value in pairs(cd[4]) do
						if (value>0) then 
							SendChatMessage(BLRCD['raid_members'][guid]['name']..' ready!','RAID')					
						end
					end
				end
			end
		end
	end
end

function BLRCD.OnLeave()
   GameTooltip:Hide()
end